/*
 * File         : Choleski_s.java
 * Author       : Guansong Zhang
 * Created      : Tue Feb  3 22:44:46 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/02/20 17:01:45 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import spmd.*;

class Choleski_s {

  static final int n= 1024;

  public static void main(String argv[]) {
    float a [][] = new float [n][n];

    int i, j, k, s;

    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	if (j>=i)
	  a[i][j]=i+1;
	else
	  a[i][j]=j+1;
      }
    }

    /*
    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	System.out.print(a[i][j]+" ");
      };
    
      System.out.println();
    }
    */

    Clock.start();

    a[0][0]=(float)Math.sqrt(a[0][0]);

    /* This is for column major
    for (k=0; k<n-1; k++) {
      for (s=k+1; s<n; s++) {
	a[s][k]/=a[k][k];
      }

      for (j=k+1; j<n; j++) {
	for (i=j; i<n; i++) {
	  a[i][j]-=a[i][k]*a[j][k];
	}
      }

      a[k+1][k+1]=(float)Math.sqrt(a[k+1][k+1]);

    }
    */

    // reverse i, j for row major.

    for (k=0; k<n-1; k++) {
      for (s=k+1; s<n; s++) {
	a[k][s]/=a[k][k];
      }

      for (j=k+1; j<n; j++) {
	for (i=j; i<n; i++) {
	  a[j][i]-=a[k][i]*a[k][i];
	}
      }

      a[k+1][k+1]=(float)Math.sqrt(a[k+1][k+1]);

    }

    Clock.stop();

    /*
    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	System.out.print(a[i][j]+" ");
      };
    
      System.out.println();
    }
    */
  }
}
